local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

c.Init(a)

local function evangelismStack()
	local stack = c.GetBuffStack("Evangelism")
	if c.IsCasting("Holy Fire") or c.IsCasting("Smite") then
		stack = stack + 1
	end
	return stack
end

c.AddSpell("Holy Fire", nil, {
	NotIfActive = true,
	NoStopChannel = true,
})

c.AddSpell("Pennance", "at 2", {
	CheckFirst = function()
		return evangelismStack() >= 2
	end
})

c.AddSpell("Pennance", "at 4", {
	CheckFirst = function()
		return evangelismStack() >= 4
	end
})

c.AddOptionalSpell("Power Word: Fortitude", nil, {
    NoRangeCheck = true,
    CheckFirst = function()
        return c.RaidBuffNeeded(c.STAMINA_BUFFS)
    end
})

c.AddOptionalSpell("Shadow Protection", nil, {
    NoRangeCheck = true,
    CheckFirst = function()
        return c.RaidBuffNeeded(c.SHADOW_RESISTANCE_BUFFS)
    end
})

c.AddOptionalSpell("Inner Fire", nil, {
    Buff = "Inner Fire",
    BuffUnit = "player",
})

c.AddOptionalSpell("Power Word: Shield", nil, {
	NoRangeCheck = true,
	Override = function(z)
		if s.MyBuff(z.ID, a.ShieldTarget) then
			return false
		end
		
		local manaReturn = s.MaxPower("player")
		local rank = c.GetTalentRank("Rapture")
		if rank == 1 then
			manaReturn = manaReturn * .02
		elseif rank == 2 then
			manaReturn = manaReturn * .05
		elseif rank == 3 then
			manaReturn = manaReturn * .07
		else
			return false
		end
		return manaReturn > c.GetCost("Power Word: Shield")
	end
})

c.AddOptionalSpell("Power Infusion", nil, { NoRangeCheck = true })

c.AddOptionalSpell("Archangel", nil, {
	NoRangeCheck = true,
	CheckFirst = function()
		return c.GetBuffStack("Evangelism") == 5
	end
})

c.AddOptionalSpell("Shadowfiend", nil, {
    CheckFirst = function()
        return s.PowerPercent("player") < 70
    end
})

c.AddSpell("Shadow Word: Death", nil, {
    NoStopChannel = true,
    CheckFirst = function(z)
        if s.HealthPercent() > 25 then
            z.FlashColor = "yellow"
            z.Continue = true
            return s.PowerPercent("player") < 30
        else
            z.FlashColor = nil
            z.Continue = nil
            return true
        end
    end
})

c.AddOptionalSpell("Devouring Plague", nil, {
    MyDebuff = "Devouring Plague",
    NoStopChannel = true,
})
c.ManageDotRefresh("Devouring Plague", 3)

c.AddOptionalSpell("Shadow Word: Pain", nil, {
    MyDebuff = "Shadow Word: Pain",
    NoStopChannel = true,
})
c.ManageDotRefresh("Shadow Word: Pain", 3)

c.AddSpell("Mind Blast", nil, {
    NotIfActive = true,
    NoStopChannel = true,
})
